/*
*  main.c
*
*   file ۱ Կ ֽϴ.
*  ۱ ڼ  README ۱ κ ñ ٶϴ.
*
*  Copyright: Oh, SungKyu 
*  Sun Oct 15 22:58:20 KST 1995
*
*/



#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xmu/Xmu.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/Viewport.h>

#include "prop.h"

char *menu_string[MENU_NUM][MENU_ITEMNUM] = {
	{ "", "ѱ" },
	{ "2", "3" },
	{ "", "" },
};
int menu_index[MENU_NUM] = { 0, 0 };

Widget button[MENU_NUM];
Widget menu[MENU_NUM];
Widget inputText;

void Quit();
void AddMenuItem();


main(argc, argv)
int argc;
char *argv[];
{
    Widget toplevel;
    Widget pane;
    Widget commandBox;
    Widget quitButton;
    Widget fieldBox;
    Widget viewPort;

    Arg args[10];

    XEvent event;
    int i;


    putenv("HANX_INPUT_DISABLE=1");

    toplevel = XtInitialize(argv[0], "Generic", NULL, 0, &argc, argv);

    pane = XtCreateManagedWidget("pane", panedWidgetClass, toplevel, NULL, 0);

    XtSetArg(args[0], XtNwidth, 8*40);
    viewPort = XtCreateManagedWidget(
			"viewPort", viewportWidgetClass, pane, args, 1);

    XtSetArg(args[0], XtNjustify, XtJustifyLeft);
    XtSetArg(args[1], XtNlabel, "\"Է  ̰ Ÿϴ.\"");
    inputText = XtCreateManagedWidget(
			"inputText", labelWidgetClass, viewPort, args, 2);

    fieldBox = XtCreateManagedWidget(
			"fieldBox", boxWidgetClass, pane, NULL, 0);

    for (i = 0; i < MENU_NUM; i++) {
	button[i] = XtCreateManagedWidget(menu_string[i][menu_index[i]],
		    menuButtonWidgetClass, fieldBox, NULL, 0);
	menu[i] = XtCreatePopupShell(
		    "menu", simpleMenuWidgetClass, button[i], NULL, 0);
	AddMenuItem(i, menu_string[i]);
    }

    XtSetArg(args[0], XtNlabel, "");
    quitButton = XtCreateManagedWidget("quitButton", 
		commandWidgetClass, fieldBox, args, 1);
    XtAddCallback(quitButton, XtNcallback, Quit, NULL);

    XtRealizeWidget(toplevel);

    Init(XtDisplay(toplevel));

    XSelectInput(XtDisplay(toplevel), DefaultRootWindow(XtDisplay(toplevel)), 
	PropertyChangeMask);

    while (1) {
	XtNextEvent (&event);
	switch (event.type) {
	case PropertyNotify:
	    PropertyNotified(&event);
	    break;
	default:
	    XtDispatchEvent(&event);
	    break;
	}
    }
}


void MenuSelected(w, closure, callData)
    Widget w;
    XtPointer closure, callData;
{
    int n = (int)closure;
    int m = n / MENU_ITEMNUM;
    int i = n % MENU_ITEMNUM;
    Arg args[1];

    XtSetArg(args[0], XtNlabel, menu_string[m][i]);
    XtSetValues( button[m], args, 1);

    ChangeMenuIndex(m, i);
}

void AddMenuItem(m, str)
    int m;
    char *str[];
{
    Widget item;
    Arg args[1];
    int i;

    for (i = 0; i < MENU_ITEMNUM && str[i]; i++) {
	XtSetArg( args[0], XtNlabel, str[i]);
	item = XtCreateManagedWidget("item", 
	    smeBSBObjectClass, menu[m], args, 1);
	XtAddCallback(item, XtNcallback, 
		MenuSelected, (char*)(m * MENU_ITEMNUM + i));
    }
}

void Quit(w, closure, callData)
    Widget w;
    XtPointer closure, callData;
{
    XtCloseDisplay(XtDisplay(w));
    exit(0);
}
