/*
*  prop.c
*
*   file ۱ Կ ֽϴ.
*  ۱ ڼ  README ۱ κ ñ ٶϴ.
*
*  Copyright: Oh, SungKyu 
*  Sun Oct 15 22:58:20 KST 1995
*
*/


#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include "HanXHangul.h"
#include "prop.h"

void UpdateMenu();
void ChangeString(/*string, length*/);

void	change_lang_hangul();
void	change_lang_english();
void	change_length_letter();
void	change_length_line();
void	change_keyboard_3beol();
void	change_keyboard_2beol();

#if 0
#define CONCAT3(a,b,c) a/**/b/**/c
#define CONCAT4(a,b,c,d) a/**/b/**/c/**/d
#else
#define CONCAT3(a,b,c) a##b##c
#define CONCAT4(a,b,c,d) a##b##c##d
#endif

#define NewInputMode(m,v) \
	((InputMode & ~CONCAT3(HANX_INPUT_MODE_,m,_MASK)) \
	| CONCAT4(HANX_INPUT_MODE_,m,_,v))

#define FONTNAME \
	"-schumacher-clean-medium-r-normal--16-160-75-75-c-80-iso8859-1"

#define ChangeInputModeTo(v)  SetInputModeTo(v), BroadcastInputMode()

void SetInputModeTo(/*newmode*/);
void BroadcastInputMode();

Display *dpy;
Window root;
HANX_InputDataType InputData;
HANX_InputModeType InputMode;

void RefreshInputData()
{
    {
        char text[sizeof(InputData.string)+sizeof(InputData.combining)];
        int length;

        strncpy(text, InputData.string, InputData.length);
        length = InputData.length;
        strcpy(text+length, InputData.combining);
        length = strlen(text);

	ChangeString(text, length);
    }

    XFlush(dpy);
}

void
RefreshInputMode()
{
    char language[20];
    char keyboard[20];
    char left_footer[100];

    language[0] = keyboard[0] = 0;

    if ((InputMode & HANX_INPUT_MODE_LANG_MASK) ==
            HANX_INPUT_MODE_LANG_ENGLISH)
	menu_index[MENU_INDEX_LANG] = MENU_VALUE_ENGLISH;
    else
/*
    if ((InputMode & HANX_INPUT_MODE_LANG_MASK) ==
            HANX_INPUT_MODE_LANG_HANGUL)
*/
	menu_index[MENU_INDEX_LANG] = MENU_VALUE_HANGUL;

    if ((InputMode & HANX_INPUT_MODE_KEYBOARD_MASK) ==
            HANX_INPUT_MODE_KEYBOARD_3BEOL)
	menu_index[MENU_INDEX_KEYBOARD] = MENU_VALUE_3BEOL;
    else
/*
    if ((InputMode & HANX_INPUT_MODE_KEYBOARD_MASK) ==
            HANX_INPUT_MODE_KEYBOARD_2BEOL)
*/
	menu_index[MENU_INDEX_KEYBOARD] = MENU_VALUE_2BEOL;

    if ((InputMode & HANX_INPUT_MODE_LENGTH_MASK) ==
            HANX_INPUT_MODE_LENGTH_LETTER)
	menu_index[MENU_INDEX_LENGTH] = MENU_VALUE_LETTER;
    else
/*
    if ((InputMode & HANX_INPUT_MODE_LENGTH_MASK) ==
            HANX_INPUT_MODE_LENGTH_LINE)
*/
	menu_index[MENU_INDEX_LENGTH] = MENU_VALUE_LINE;

    UpdateMenu();
}

void
Refresh()
{
    RefreshInputMode();
    RefreshInputData();
}

void
SetInputModeTo(mode)
HANX_InputModeType mode;
{
    InputMode = mode;
    RefreshInputMode();
}

SetInputDataTo(d)
HANX_InputDataType *d;
{
    InputData = *d;
    RefreshInputData();
}

void
GetInputData()
{
    Atom type;
    int format;
    unsigned long n;
    unsigned long left;
    HANX_InputDataType *s;

    XGetWindowProperty(dpy, root, HANX_INPUT_DATA, 0L, BUFSIZ,
        0, HANX_INPUT_DATA_TYPE, &type, &format, &n, &left, 
	(unsigned char **)&s);

    if (s && type == HANX_INPUT_DATA_TYPE && n == sizeof(*s)) {
        SetInputDataTo(s);
    }

    if (s)
        XFree (s);
}

void
GetInputMode()
{
    Atom type;
    int format;
    unsigned long n;
    unsigned long left;
    HANX_InputModeType *modeptr;

    XGetWindowProperty(dpy, root, HANX_INPUT_MODE, 0L, BUFSIZ,
        0, HANX_INPUT_MODE_TYPE, &type, &format, &n, &left, 
	(unsigned char **)&modeptr);

    if (modeptr && type == HANX_INPUT_MODE_TYPE && n == sizeof(*modeptr)) {
        if (*modeptr != InputMode)
            SetInputModeTo(*modeptr);
    }

    if (modeptr)
        XFree (modeptr);
}


void
BroadcastInputMode()
{
    XChangeProperty(dpy, root, HANX_INPUT_MODE, HANX_INPUT_MODE_TYPE,
        8, PropModeReplace, (unsigned char *)&InputMode, sizeof(InputMode));
}



void
PropertyNotified(xevent)
XEvent *xevent;
{
    if (xevent->xproperty.window == root &&
	    xevent->xproperty.atom == HANX_INPUT_DATA) {
	GetInputData();
    }
    else if (xevent->xproperty.window == root &&
	    xevent->xproperty.atom == HANX_INPUT_MODE) {
	GetInputMode();
    }
}

void
Init(display)
Display *display;
{
    dpy = display;
    root = DefaultRootWindow(display);

    ChangeInputModeTo(0);
}

/*
*
*
*/


static int menu_index_old[MENU_NUM] = {-1};

void
UpdateMenu()
{
    int m;
    Arg args[1];

    for (m = 0; m < MENU_NUM; m++) {
	if (menu_index[m] != menu_index_old[m]) {
	    XtSetArg(args[0], XtNlabel, menu_string[m][menu_index[m]]);
	    XtSetValues(button[m], args, 1);
	    menu_index_old[m] = menu_index[m];
	}
    }
}

void
ChangeString(string, length)
char *string;
int length;
{
    Arg args[1];

    string[length] = 0;
    XtSetArg(args[0], XtNlabel, string);
    XtSetValues(inputText, args, 1);
}

void ChangeMenuIndex(m, i)
int m;
int i;
{
    menu_index[m] = i;
    switch (m) {
    case MENU_INDEX_LANG:
	switch (i) {
	case MENU_VALUE_ENGLISH: 
	    ChangeInputModeTo( NewInputMode(LANG,ENGLISH) );
	    break;
	case MENU_VALUE_HANGUL:
            ChangeInputModeTo( NewInputMode(LANG,HANGUL) );
	    break;
	}
	break;
    case MENU_INDEX_KEYBOARD:
	switch (i) {
	case MENU_VALUE_2BEOL: 
            ChangeInputModeTo( NewInputMode(KEYBOARD,2BEOL) );
	    break;
	case MENU_VALUE_3BEOL: 
            ChangeInputModeTo( NewInputMode(KEYBOARD,3BEOL) );
	    break;
	}
	break;
    case MENU_INDEX_LENGTH:
	switch (i) {
	case MENU_VALUE_LETTER: 
            ChangeInputModeTo( NewInputMode(LENGTH,LETTER) );
	    break;
	case MENU_VALUE_LINE: 
            ChangeInputModeTo( NewInputMode(LENGTH,LINE) );
	    break;
	}
	break;
    }
}

