/*
*  HanXInput.c
*
*   file ۱ Կ ֽϴ.
*  ۱ ڼ  README ۱ κ ñ ٶϴ.
*
*  Copyright: Oh, SungKyu 
*  Sun Oct 15 22:58:20 KST 1995
*
*/



#define HLIB 1
#define DEBUG2 0
#define DEBUG3 0
#define CHANGEPROPERTY 1
#define NEED_EVENTS
#define NEED_REPLIES

#include <stdlib.h>
#include <X11/Xproto.h>
#include <X11/Xlib.h>
#include <X11/Xlibint.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>
#include "HanXHangul.h"
#ifndef FILE
#include <stdio.h>
#endif
#include <ctype.h>


static KeySym toggle_hangul_keysym = XK_space;
static int toggle_hangul_modifier = ShiftMask;
static FinishKeyCombining(/* register Display *dpy*/);
static ChangeInputModeToggle(/*register Display *dpy*/);
static GenerateKeyEvent(/* Display *dpy, unsigned char *str, int len */);

/**********************************************************/
	
/*
 * _XEnq - Place event packets on the display's queue.
 * note that no squishing of move events in V11, since there
 * is pointer motion hints....
 */
extern void _Org_XEnq();
static void (*__XEnq)() = _Org_XEnq;
void _XEnq (dpy, event)
        register Display *dpy;
        register xEvent *event;
{
    return __XEnq(dpy, event);
}

extern KeySym _OrgXLookupKeysym();
static KeySym (*_XLookupKeysym)() = _OrgXLookupKeysym;
KeySym
XLookupKeysym(event, col)
    register XKeyEvent *event;
    int col;
{
    return _XLookupKeysym (event, col);
}

extern int _OrgXLookupString();
static int (*_XLookupString)() = _OrgXLookupString;
int
XLookupString (event, buffer, nbytes, keysym, status)
    register XKeyEvent *event;
    char *buffer;       /* buffer */
    int nbytes; /* space in buffer for characters */
    KeySym *keysym;
    XComposeStatus *status;     /* not implemented */
{
    return _XLookupString (event, buffer, nbytes, keysym, status);
}

/*
extern int _OrgXmbLookupString();
static int (*_XmbLookupString)() = _OrgXmbLookupString;
int
XmbLookupString(ic, ev, buffer, nbytes, keysym, status)
    XIC ic;
    register XKeyEvent *ev;
    char *buffer;
    int nbytes;
    KeySym *keysym;
    Status *status;
{
    _XmbLookupString(ic, ev, buffer, nbytes, keysym, status);
}
*/

extern HanXCursorStringChange(/*dpy, HanX_InputData.combining*/);

/**********************************************************/

#if DEBUG3 || DEBUG2
static debug(s)
char *s;
{
    FILE *fp = fopen("debug.out", "a");
    fprintf(fp, "%s\n", s);
    fclose(fp);
}
#endif

/**********************************************************/

int HanXInput = 0;
static int HanX_InputKeyboard = 2;

static struct automata *automata = 0;
static HANX_InputDataType HanX_InputData;
static HANX_InputModeType HanX_InputMode = 0;
static int HanX_InputDataChanged = 0;
static int HanX_InputModeChanged = 0;
static int HanX_PropertyNotify = 0;


static int is_HanX_InputMode_length_line()
{
    return (HanX_InputMode & HANX_INPUT_MODE_LENGTH_MASK)
	== HANX_INPUT_MODE_LENGTH_LINE;
}
    
static int is_HanX_InputMode_length_letter()
{
    return (HanX_InputMode & HANX_INPUT_MODE_LENGTH_MASK)
	== HANX_INPUT_MODE_LENGTH_LETTER;
}
    
static ResetInputData()
{
    HanX_InputData.length = 0;
    HanX_InputData.curpos = 0;
    HanX_InputDataChanged = 1;
}

static SendInputData(dpy)
Display *dpy;
{
    GenerateKeyEvent(dpy, HanX_InputData.string, HanX_InputData.length);
    ResetInputData();
}


static void 
HanX_GetInputMode(dpy)
Display *dpy;
{
    Atom type;
    int format;
    unsigned long n;
    unsigned long left;
    unsigned long value;
    HANX_InputModeType *mode;
    Window root = DefaultRootWindow(dpy);

    XGetWindowProperty(dpy, root, HANX_INPUT_MODE, 0L, BUFSIZ, 
	0, HANX_INPUT_MODE_TYPE, 
	&type, &format, &n, &left, (unsigned char **)&mode);

    if (mode && type == HANX_INPUT_MODE_TYPE 
		&& n == sizeof(HanX_InputMode) ) {
        if (*mode != HanX_InputMode)
            FinishKeyCombining(dpy);
	if ((HanX_InputMode & HANX_INPUT_MODE_LANG_MASK) !=
		(*mode & HANX_INPUT_MODE_LANG_MASK))
	{
	    if (
		((*mode & HANX_INPUT_MODE_LANG_MASK) 
		    == HANX_INPUT_MODE_LANG_HANGUL 
		    && !automata->hangul_state_) ||
		((*mode & HANX_INPUT_MODE_LANG_MASK)
		== HANX_INPUT_MODE_LANG_ENGLISH 
		    && automata->hangul_state_)) {
		ChangeInputModeToggle();
	    }
	}
	if ((HanX_InputMode & HANX_INPUT_MODE_KEYBOARD_MASK) !=
		(*mode & HANX_INPUT_MODE_KEYBOARD_MASK)) {
	    value = *mode & HANX_INPUT_MODE_KEYBOARD_MASK;
	    switch (value) {
	    default:
	    case HANX_INPUT_MODE_KEYBOARD_2BEOL:
	        HanX_InputKeyboard = 2;
		automata->keyboard_ = HanX_InputKeyboard;
		break;
	    case HANX_INPUT_MODE_KEYBOARD_3BEOL:
	        HanX_InputKeyboard = 3;
		automata->keyboard_ = HanX_InputKeyboard;
		break;
	    }
        }
	HanX_InputMode = *mode;
    }

#if DEBUG2
    printf("HanX_GetInputMode(): HanX_InputMode = %u\n", HanX_InputMode);
#endif

    if (mode)
	XFree (mode);
}

static xEvent oldevent;

static ResetSeqNumber(dpy, event)
	register Display *dpy;
	register xEvent *event;
{
    unsigned long newseq;
    unsigned long lastseq;

    newseq = (dpy->last_request_read & ~((unsigned long)0xffff)) |
	   event->u.u.sequenceNumber;
    lastseq = dpy->last_request_read;
/*
    if (newseq < lastseq) 
	event->u.u.sequenceNumber = lastseq;
*/
#if DEBUG2
    printf("ResetSeqNumber: type = %d, event->u.u.sequenceNumber = 0x%x\n", 
	event->u.u.type, event->u.u.sequenceNumber);
    printf("         newseq = 0x%x, lastseq = 0x%x\n, dpy->request = 0x%x\n", 
	newseq, lastseq, dpy->request);
#endif
    dpy->last_request_read = newseq;
}

static int IsCombining()
{
    return automata->temp_hangul_[0] != '\0';
}

static InputAutomata(dpy, ch)
Display *dpy;
unsigned ch;
{
    if (ch == '\b' && !IsCombining() && is_HanX_InputMode_length_line()) {
	if (HanX_InputData.curpos > 0) {
	    int i;
	    int move;

	    if ((HanX_InputData.string[HanX_InputData.curpos-1] & 0x80) &&
		    HanX_InputData.curpos >= 2) 
		move = 2;
	    else 
		move = 1;

	    for (i = HanX_InputData.curpos; i < HanX_InputData.length; i++) {
		HanX_InputData.string[i-move] = HanX_InputData.string[i];
	    }

	    HanX_InputData.curpos -= move;
	    HanX_InputData.length -= move;
	    HanX_InputDataChanged = 1;
	}
    }
    else {
	int i, l, second;
	unsigned code;
	unsigned char string[100];

	l = HanX_hangul_automata(automata, ch, string);
	if (l != 0 || automata->temp_hangul_[0] || HanX_InputData.combining[0]) 
	{
	    HanXCursorStringChange(dpy, automata->temp_hangul_);
	    HanX_InputDataChanged = 1;
        }
	strcpy(HanX_InputData.combining, automata->temp_hangul_);

	if (is_HanX_InputMode_length_letter()) {
	    if (l > 0) {
		strncpy(HanX_InputData.string, string, l);
		HanX_InputData.length = l;
		HanX_InputData.curpos = l;
		SendInputData(dpy);
	    }
	}
	else if (l > 0 && is_HanX_InputMode_length_line()) {
	    for (i = HanX_InputData.curpos; i < HanX_InputData.length; i++) {
		HanX_InputData.string[i+l] = HanX_InputData.string[i];
	    }
	    for (i = 0; i < l; i++) {
		HanX_InputData.string[HanX_InputData.curpos+i] = string[i];
	    }
	    HanX_InputData.curpos += l;
	    HanX_InputData.length += l;
#if 0
	    if (ch == (unsigned)-1 || ch == (unsigned)-2)
#else
	    if (ch == (unsigned)-2)
#endif
		SendInputData(dpy);
	}
    }
}


static FinishKeyCombining(dpy)
	register Display *dpy;
{
    InputAutomata(dpy, -2);
}

static ChangeInputModeToggle(dpy)
	register Display *dpy;
{
    InputAutomata(dpy, -1);
}

int HanXInputReflect(dpy)
Display *dpy;
{
    Window rootwin;

    if (HanX_InputModeChanged) {
        HanX_InputModeChanged = 0;
	rootwin = DefaultRootWindow(dpy);
#if CHANGEPROPERTY
	XChangeProperty(dpy, rootwin,
	    HANX_INPUT_MODE, HANX_INPUT_MODE_TYPE,
	    32, PropModeReplace, 
	    (_Xconst unsigned char *)&HanX_InputMode, sizeof(HanX_InputMode));
#endif
    }
    if (HanX_InputDataChanged) {
        HanX_InputDataChanged = 0;
	rootwin = DefaultRootWindow(dpy);
#if CHANGEPROPERTY
	XChangeProperty(dpy, rootwin, 
	    HANX_INPUT_DATA, HANX_INPUT_DATA_TYPE,
	    32, PropModeReplace,
	    (_Xconst unsigned char *)&HanX_InputData, sizeof(HanX_InputData));
#if DEBUG2
	printf("HanXInputReflect(): combining = '%s'\n", HanX_InputData.combining);
#endif
#endif
    }
    if (HanX_PropertyNotify) {
        HanX_PropertyNotify = 0;
        HanX_GetInputMode(dpy);
    }
}


/*
    ProcessKeyEvent(dpy, ev)

    Ű event ޴´.
    丶Ÿ  ˸´ ڵ带 Ѵ.
     ڵ带 XKeyEvent ٽ  queue ִ´.
*/

static int ProcessKeyEvent(dpy, event)
        register Display *dpy;
        register XKeyEvent *event;
{
    KeySym ksym;
    char buffer[BUFSIZ];

    int l;
    int enq;

    l = _OrgXLookupString(event, buffer, sizeof(BUFSIZ), &ksym, NULL);
    enq = 1;

    if ((ksym == toggle_hangul_keysym) && 
	(event->state & toggle_hangul_modifier || !toggle_hangul_modifier)) {
	ChangeInputModeToggle(dpy);
	enq = 0;
        return enq;
    }

    if (event->state & ~(ShiftMask | ControlMask)) {
        FinishKeyCombining(dpy);
	return enq;
    }

    if (is_HanX_InputMode_length_line()) {
        if (l > 0) {
	    if (isprint(buffer[0])) {
		InputAutomata(dpy, (unsigned)buffer[0]);
		enq = 0;
		return enq;
	    }
	    if (buffer[0] == '\b' || buffer[0] == 127) {
		InputAutomata(dpy, (unsigned)'\b');
		enq = 0;
		return enq;
	    }

	    FinishKeyCombining(dpy);
	    SendInputData(dpy);

	    return enq;
        }
	if (ksym < XK_Shift_L) {
	    FinishKeyCombining(dpy);
	    SendInputData(dpy);
	    return enq;
	}
    }

    if (automata->hangul_state_) {
	if (l > 0) {
	    if (buffer[0] == '\033') {
		ChangeInputModeToggle(dpy); /* to english */
		return enq;
	    }

            if(HanX_InputKeyboard == 2)
	      {
		if (('A' <= buffer[0] && buffer[0] <= 'Z' || 
		     'a' <= buffer[0] && buffer[0] <= 'z') ) { 
		  InputAutomata(dpy, (unsigned)buffer[0]);
		  enq = 0;
		  return enq;
		}
	      }
	    else if(HanX_InputKeyboard == 3)
	      {
		if (('!' <= buffer[0] && buffer[0] <= 'z') ) { 
		  InputAutomata(dpy, (unsigned)buffer[0]);
		  enq = 0;
		  return enq;
		}
	      }
	    if (buffer[0] == 127) buffer[0] = '\b';
	    if (buffer[0] == '\b' && IsCombining()) {
		InputAutomata(dpy, (unsigned)'\b');
		enq = 0;
		return enq;
	    }
	}
	if (ksym < XK_Shift_L) {
	    FinishKeyCombining(dpy);
	    return enq;
	}
    }

    return enq;
}


static GenerateKeyEvent(dpy, str, len)
Display *dpy;
unsigned char *str;
int len;
{
    int i;

    for (i = 0; i < len; i++) {
	ResetSeqNumber(dpy, &oldevent);
	if (str[i] & 0x80) {
	    oldevent.u.u.detail = (KeyCode) str[i];
	    oldevent.u.keyButtonPointer.state = 0;
	}
	else {
	    oldevent.u.u.detail = (KeyCode) XKeysymToKeycode(dpy, str[i]);
	    if (XKeycodeToKeysym(dpy, (KeyCode)oldevent.u.u.detail, 0) != str[i]) 
		oldevent.u.keyButtonPointer.state = ShiftMask;
	    else 
		oldevent.u.keyButtonPointer.state = 0;
        }
	_Org_XEnq(dpy, &oldevent);
    }
}

static PreprocessxEvent(dpy, event)
	register Display *dpy;
	register xEvent *event;
{
    XComposeStatus *status;
    unsigned old_hangul_state;
    HANX_InputModeType old_HanX_InputMode;
    XKeyEvent xkeyevent;
    XKeyEvent *ev = &xkeyevent;

    ev->type = event->u.u.type & 0x7f;

    if (ev->type == PropertyNotify) {
	if (event->u.property.window == DefaultRootWindow(dpy) &&
		event->u.property.atom == HANX_INPUT_MODE) {
	    HanX_PropertyNotify = 1;
	    return;
	}
    }
    else if (( ev->type != KeyPress 
	  || oldevent.u.keyButtonPointer.event 
	     != event->u.keyButtonPointer.event)) {

	FinishKeyCombining(dpy, event);
    }

    old_hangul_state = automata->hangul_state_;
    old_HanX_InputMode = HanX_InputMode;

    if (ev->type != KeyPress) {
	ResetSeqNumber(dpy, event);
	_Org_XEnq(dpy, event);
    }
    else {
	int enq;

	ev->root        = event->u.keyButtonPointer.root;
	ev->window      = event->u.keyButtonPointer.event;
	ev->subwindow   = event->u.keyButtonPointer.child;
	ev->time        = event->u.keyButtonPointer.time;
	ev->x           = cvtINT16toInt(event->u.keyButtonPointer.eventX);
	ev->y           = cvtINT16toInt(event->u.keyButtonPointer.eventY);
	ev->x_root      = cvtINT16toInt(event->u.keyButtonPointer.rootX);
	ev->y_root      = cvtINT16toInt(event->u.keyButtonPointer.rootY);
	ev->state       = event->u.keyButtonPointer.state;
	ev->same_screen = event->u.keyButtonPointer.sameScreen;
	ev->keycode     = event->u.u.detail;
	ev->display = dpy;

	oldevent = *event;
	enq = ProcessKeyEvent(dpy, ev);

	if (enq) {
	    ResetSeqNumber(dpy, event);
	    _Org_XEnq(dpy, event);
	}
#if DEBUG2
	printf("PreprocessxEvent(KeyEvent): length = %d, curpos = \n", 
	    HanX_InputData.length, HanX_InputData.curpos);
#endif
    }


    if (old_hangul_state != automata->hangul_state_) {
#if DEBUG2
	printf("change: old HanX_InputMode = %u\n");
#endif
	HanX_InputMode = (HanX_InputMode & ~HANX_INPUT_MODE_LANG_MASK)
		| (automata->hangul_state_ ? HANX_INPUT_MODE_LANG_HANGUL
					: HANX_INPUT_MODE_LANG_ENGLISH);
#if DEBUG2
	printf("change: HanX_InputMode = %u\n");
#endif
    }

    if (old_HanX_InputMode != HanX_InputMode) {
	HanX_InputModeChanged = 1;
    }

    HanX_InputData.window = event->u.keyButtonPointer.event;
}

/*
 * _XEnq - Place event packets on the display's queue.
 * note that no squishing of move events in V11, since there
 * is pointer motion hints....
 */
static void Han_XEnq (dpy, event)
        register Display *dpy;
        register xEvent *event;
{
#if DEBUG2
    debug("_H_XEnq: start");
#endif

    if ((event->u.u.type & 0177) == KeyPress 
		|| (event->u.u.type & 0177) == PropertyNotify
		|| (event->u.u.type & 0177) == ButtonPress
		|| (event->u.u.type & 0177) == FocusOut
		|| (event->u.u.type & 0177) == LeaveNotify
	) {
        PreprocessxEvent(dpy, event);
    }
    else 
    {
        _Org_XEnq(dpy, event);
    }
#if DEBUG2
    debug("_H_XEnq: start");
#endif
}

KeySym
HanXLookupKeysym(event, col)
    register XKeyEvent *event;
    int col;
{

#if DEBUG3
    debug("HanXLookupKeysym: start");
#endif

    if (event->keycode > event->display->max_keycode) {
        return event->keycode;
    }
    else {
        return _OrgXLookupKeysym(event, col);
    }

#if DEBUG3
    debug("HanXLookupKeysym: end");
#endif
}


static int
HanXLookupString (event, buffer, nbytes, keysym, status)
    register XKeyEvent *event;
    char *buffer;       /* buffer */
    int nbytes; /* space in buffer for characters */
    KeySym *keysym;
    XComposeStatus *status;     /* not implemented */
{
    int r;

#if DEBUG3
    debug("HanXLookupString: start");
#endif

    if (event->keycode > event->display->max_keycode) {
        if (keysym) *keysym = event->keycode;
	if (buffer && nbytes > 0) buffer[0] = event->keycode;
	r = 1;
    }
    else {
	r = _OrgXLookupString(event, buffer, nbytes, keysym, status);
    }

#if DEBUG3
    debug("HanXLookupString: end");
#endif

    return r;
}

#if 0 /* hanmaum 1995.10.15 2:03 */
int
HanXmbLookupString(ic, ev, buffer, nbytes, keysym, status)
    XIC ic;
    register XKeyEvent *ev;
    char *buffer;
    int nbytes;
    KeySym *keysym;
    Status *status;
{
    int r;

#if DEBUG2
    debug("HanXmbLookupString: start");
#endif

    /* preprocessed key event */
    if ((ev->type & 0177) == KeyPress && ev->y_root == -1) {
	if (ev->x_root & 0x8000) {
	    *buffer = (ev->x_root >> 8) & 0xff;
	    *(buffer+1) = ev->x_root & 0xff;
	    if (keysym) *keysym = XK_A;
	    r = 2;
	    *status = XLookupKeySym;
	}
	else {
	    *buffer = ev->x_root & 0xff;
	    if (*buffer & 0x80) {
		r = 0;
		if (keysym) *keysym = NoSymbol;
		*status = XLookupNone;
	    }
	    else {
		if (keysym) *keysym = XK_A;
		r = 1;
		*status = XLookupKeySym;
	    }
	}
    }
    else 
    {
	r = _OrgXmbLookupString(ic, ev, buffer, nbytes, keysym, status);
    }

#if DEBUG2
    debug("HanXmbLookupString: end");
#endif

    return r;
}
#endif


/************************************************************************/

static int initialized = 0;

_HanXInputInit(dpy)
Display *dpy;
{
    char *disable;

#if DEBUG2
    debug("init: start");
#endif
    disable = getenv("HANX_INPUT_DISABLE");
#if 1
    HanXInput = (disable == NULL || atoi(disable) == 0);
#else
    HanXInput = disable != NULL && atoi(disable) != 1;
#endif

    if (HanXInput) {
	char *str;

	__XEnq = Han_XEnq;
	_XLookupString = HanXLookupString;
	_XLookupKeysym = HanXLookupKeysym;
#if 0
	_XmbLookupString = HanXmbLookupString;
#endif

	HanX_InputKeyboard = 2;
	str = getenv("HANX_INPUT_KEYBOARD");
	if (str != NULL) HanX_InputKeyboard = atoi(str);

	if (!automata) automata = HanX_automata_new
		(HanX_InputKeyboard, 0);

	initialized = 1;

	XSelectInput(dpy, DefaultRootWindow(dpy), PropertyChangeMask);

	HanX_GetInputMode(dpy);
    }
}

