/*
*  HanXIntFnt.c
*
*   file ۱ Կ ֽϴ.
*  ۱ ڼ  README ۱ κ ñ ٶϴ.
*
*  Copyright: Oh, SungKyu 
*  Sun Oct 15 22:58:20 KST 1995
*
*/



#include <X11/Xlib.h>
#include <stdio.h>

#define DEBUG 0
#define MAXPOINTS 35

typedef struct {
    float x, y;
} Point;

struct vectorfont {
    Point points[MAXPOINTS];
    int npoints;
    int size;
} HanXSimpleHangulVectorFont[] = {
    { 
	{{ 0, 0 }},
        0  /* null */, 16
    }, {
	{{ 1.5, 1 }, { 7.5, 1 }, { 7.5, 5 }, { 0, 0 }},
        -1  /*  */, 16
    }, {
	{{ 2, 1 }, { 4, 1 }, { 4, 5 }, { 0, 0 },
	{ 4 , 1 }, { 7, 1 }, { 7, 5 }, { 0, 0 }}, 
        -2 /*  */ , 16
    }, {
	{{ 2, 1 }, { 2, 5 }, { 7, 5 }, { 0, 0 }},
        -1 /*  */ , 16
    }, {
	{{ 7, 1 }, { 2, 1 }, { 2, 5 }, { 7, 5 }, { 0, 0 }},
        -1 /*  */ , 16
    }, {
	{{ 4, 1 }, { 1.5, 1 }, { 1.5, 5 }, { 4, 5 }, { 0, 0 },
	{ 7.5, 1 }, { 5, 1 }, { 5, 5 }, { 7.5, 5 }, { 0, 0 }},
        -2 /* */ , 16
    }, {
	{{ 1.5, 1 }, { 7, 1 }, { 7, 3 }, { 1.5, 3 }, { 1.5, 5 }, 
	{ 7, 5 }, { 0, 0 }},
        -1 /* */, 16
    }, {
	{{ 2, 1 }, { 7, 1 }, { 7, 5 }, { 2, 5 }, { 2, 1 }, { 0, 0 }}, 
        -1 /* */, 16
    }, {
	{{ 2, 1 }, { 2, 5 }, { 7, 5 }, { 7, 1 }, { 0, 0 }, 
	{ 2, 3 }, { 7, 3 }, { 0, 0 }},
        -2 /* */, 16
    }, {
	{{ 1, 1 }, { 1, 5 }, { 7, 5 }, { 7, 1 }, { 0, 0 }, 
	{ 1, 3 }, { 7, 3 }, { 0, 0 },
	{ 4, 1 }, { 4, 5 }, { 0, 0 }},
        -3 /* */, 16
    }, {
	{{ 4, 1 }, { 4, 2 }, { 1, 5 }, { 0, 0 },
	{ 4, 2 }, { 7, 5 }, { 0, 0 }}, 
        -2 /* */, 16
    }, {
	{{ 3, 1 }, { 3, 2 }, { 1, 5 }, { 0, 0 },
	{ 3, 2 }, { 5, 5 }, { 0, 0 },
	{ 6, 1 }, { 6, 2 }, { 4, 5 }, { 0, 0 },
	{ 6, 2 }, { 8, 5 }, { 0, 0 }},
        -4 /* */, 16
    }, {
	{ { 4, 1 }, { 5, 1 }, { 7, 2 }, { 7, 4 }, { 5, 5 }, 
	{ 4, 5 }, { 2, 4 }, { 2, 2 }, { 4, 1 }, { 0, 0 }},
        -1 /*  */, 16
    }, {
	{{ 1, 1 }, { 7, 1 }, { 0, 0 },
	{ 4, 1 }, { 4, 2 }, { 0, 0 },
	{ 1, 5 }, { 4, 2 }, { 7, 5 }, { 0, 0 }},
        -3  /*  */, 16
    }, {
	{{ 1, 1 }, { 8, 1 }, { 0, 0 },
	{ 3, 1 }, { 3, 3 }, { 0, 0 },
	{ 1, 5 }, { 3, 3 }, { 5, 5 }, { 0, 0 },
	{ 6, 1 }, { 6, 3 }, { 0, 0 },
	{ 4, 5 }, { 6, 3 }, { 8, 5 }, { 0, 0 }},
        -5  /*  */, 16
    }, {
	{{ 4, 1 }, { 4, 2 }, { 0, 0 }, 
	{ 1, 2 }, { 7, 2 }, { 0, 0 },
	{ 1, 5 }, { 4, 2 }, { 7, 5 }, { 0, 0 }},
        -3  /*  */, 16
    }, {
	{{ 2, 1 }, { 7, 1 }, { 7, 5 }, { 0, 0 },
	{ 2, 3 }, { 7, 3 }, { 0, 0 }},
        -2  /*  */, 16
    }, {
	{{ 7, 1 }, { 2, 1 }, { 2, 5 }, { 7, 5 }, { 0, 0 }, 
	{ 2, 3 }, { 5.5, 3 }, { 0, 0 }},
        -2  /*  */, 16
    }, {
	{{ 1.5, 1 }, { 8, 1 }, { 0, 0 },
	{ 3, 1 }, { 3, 5 }, { 0, 0 },
	{ 6, 1 }, { 6, 5 }, { 0, 0 },
	{ 1.5, 5 }, { 8, 5 }, { 0, 0 }},
        -4  /*  */, 16
    }, {
	{{ 4, 1 }, { 4, 2 }, { 1, 2 }, { 7, 2 }, { 0, 0 }, 
	{ 1, 4 }, { 2, 3 }, { 6, 3 }, { 7, 4 }, { 6, 5 },
	{ 2, 5 }, { 1, 4 }, { 0, 0 }},
        -2  /*  */, 16
    }, {
	{{ 11, 1 }, { 11, 7 }, { 0, 0 },
	{ 11, 3 }, { 13.5, 3 }, { 0, 0 }},
        -2  /*  */, 16
    }, {
	{{ 10, 1 }, { 10, 7 }, { 0, 0 },
	{ 10, 3 }, { 13, 3 }, { 0, 0 },
	{ 13, 1 }, { 13, 7 }, { 0, 0 }},
        -3  /*  */, 16
    }, {
	{{ 11, 1 }, { 11, 7 }, { 0, 0 },
	{ 11, 2 }, { 13.5, 2 }, { 0, 0 },
	{ 11, 4 }, { 13.5, 4 }, { 0, 0 }},
        -3  /*  */, 16
    }, {
	{{ 10, 1 }, { 10, 7 }, { 0, 0 },
	{ 10, 2 }, { 13, 2 }, { 0, 0 },
	{ 10, 4 }, { 13, 4 }, { 0, 0 },
	{ 13, 1 }, { 13, 7 }, { 0, 0 }},
        -4  /*  */, 16
    }, {
	{{ 9, 2 }, { 12, 2 }, { 0, 0 },
	{ 12, 1 }, { 12, 7 }, { 0, 0 }},
        -2  /*  */, 16
    }, {
	{{ 8, 2 }, { 11, 2 }, { 0, 0 },
	{ 11, 1 }, { 11, 7 }, { 0, 0 },
	{ 14, 1 }, { 14, 7 }, { 0, 0 }},
        -3  /*  */, 16
    }, {
	{{ 9, 2 }, { 13, 2 }, { 0, 0 },
	{ 9, 4 }, { 13, 4 }, { 0, 0 },
	{ 13, 1 }, { 13, 7 }, { 0, 0 }},
        -3  /*  */, 16
    }, {
	{{ 8, 2 }, { 11, 2 }, { 0, 0 },
	{ 8, 4 }, { 11, 4 }, { 0, 0 },
	{ 11, 1 }, { 11, 7 }, { 0, 0 },
	{ 14, 1 }, { 14, 7 }, { 0, 0 }},
        -4  /*  */, 16
    }, {
	{{ 6, 5.5 }, { 6, 7 }, { 0, 0 },
	{ 2, 7 }, { 11, 7 }, { 0, 0 }},
        -2  /*  */, 16
    }, {
	{{ 4, 5.5 }, { 4, 7 }, { 0, 0 },
	{ 1, 7 }, { 9, 7 }, { 0, 0 },
	{ 11, 1 }, { 11, 8 }, { 0, 0 }, 
	{ 11, 3 }, { 13.5, 3 }, { 0, 0 }},
        -4  /*  */, 16
    }, {
	{{ 4, 5.5 }, { 4, 7 }, { 0, 0 },
	{ 1, 7 }, { 9, 7 }, { 0, 0 },
	{ 10, 1 }, { 10, 8 }, { 0, 0 },
	{ 10, 3 }, { 13, 3 }, { 0, 0 },
	{ 13, 1 }, { 13, 8 }, { 0, 0 }},
        -5  /*  */, 16
    }, {
	{{ 4, 5.5 }, { 4, 7 }, { 0, 0 },
	{ 1, 7 }, { 9, 7 }, { 0, 0 },
	{ 11, 1 }, { 11, 8 }, { 0, 0 }}, 
        -3  /*  */, 16
    }, {
	{{ 5, 5.5 }, { 5, 7 }, { 0, 0 },
	{ 8, 5.5 }, { 8, 7 }, { 0, 0 },
	{ 2, 7 }, { 11, 7 }, { 0, 0 }},
        -3  /*  */, 16
    }, {
	{{ 2, 6 }, { 11, 6 }, { 0, 0 },
	{ 6, 6 }, { 6, 8.5 }, { 0, 0 }},
        -2  /*  */, 16
    }, {
	{{ 1, 6 }, { 4, 6 }, { 4, 8.5 }, { 4, 6 }, { 10, 6 }, { 0, 0 },
	{ 9, 3 }, { 11, 3 }, { 0, 0 },
	{ 11, 1 }, { 11, 8 }, { 0, 0 }}, 
        -3  /*  */, 16
    }, {
	{{ 1, 6 }, { 4, 6 }, { 4, 8.5 }, { 4, 6 }, { 9, 6 }, { 0, 0 },
	{ 8, 3 }, { 11, 3 }, { 0, 0 },
	{ 11, 1 }, { 11, 8 }, { 0, 0 }, 
	{ 14, 1 }, { 14, 8 }, { 0, 0 }}, 
        -4  /*  */, 16
    }, {
	{{ 1, 6 }, { 4, 6 }, { 4, 8.5 }, { 4, 6 }, { 10, 6 }, { 0, 0 },
	{ 11, 1 }, { 11, 8 }, { 0, 0 }}, 
        -2  /*  */, 16
    }, {
	{{ 2, 6 }, { 11, 6 }, { 0, 0 },
	{ 5, 6 }, { 5, 8.5 }, { 0, 0 },
	{ 8, 6 }, { 8, 8.5 }, { 0, 0 }},
        -3  /*  */, 16
    }, {
	{{ 2, 7 }, { 11, 7 }, { 0, 0 }},
        -1  /*  */, 16
    }, {
	{{ 2, 7 }, { 10, 7 }, { 0, 0 },
	{ 11, 1 }, { 11, 8 }, { 0, 0 }},
        -2  /*  */, 16
    }, {
	{{ 11, 1 }, { 11, 8 }, { 0, 0 }},
        -1  /*  */, 16
    }, {
	{{ -2, 1 }, { 2, 1 }, { 2, 5 }, { 0, 0 },
	{ 5, 1 }, { 5, 3 }, { 0, 0 },
	{ 3, 5 }, { 5, 3 }, { 7, 5 }, { 0, 0 }},
        -3  /*  */, 16
    }, {
	{{ -1, 1 }, { -1, 5}, { 2, 5 }, { 0, 0 },
	{ 3, 1 }, { 7, 1 }, { 0, 0 },
	{ 5, 1 }, { 5, 3 }, { 0, 0 },
	{ 3, 5 }, { 5, 3 }, { 7, 5 }, { 0, 0 }},
        -4  /*  */, 16
    }, {
	{{ -1, 1 }, { -1, 5}, { 2, 5 }, { 0, 0 },
	{ 5, 1 }, { 5, 2 }, { 0, 0 },
	{ 3, 2 }, { 7, 2 }, { 0, 0 },
	{ 3, 4 }, { 3, 5 }, { 4, 5 }, { 6, 5 }, { 7, 5 }, { 7, 4 },
	{ 6, 3 }, { 4, 3 }, { 3, 4 }, { 0, 0 }},
        -4  /*  */, 16
    }, {
	{{ -1, 1 }, { 2, 1 }, { 2, 3 }, { -1, 3 }, { -1, 5 }, 
	{ 2, 5 }, { 0, 0 },
	{ 3, 1 }, { 7, 1 }, { 7, 5 }, { 0, 0 }},
        -2 /* */, 16
    }, {
	{{ -1, 1 }, { 2, 1 }, { 2, 3 }, { -1, 3 }, { -1, 5 }, 
	{ 2, 5 }, { 0, 0 },
	{ 3, 1 }, { 7, 1 }, { 7, 5 }, { 3, 5 }, { 3, 1 }, { 0, 0 }},
        -2 /* */, 16
    }, {
	{{ -1, 1 }, { 2, 1 }, { 2, 3 }, { -1, 3 }, { -1, 5 }, 
	{ 2, 5 }, { 0, 0 },
	{ 3, 1 }, { 3, 5 }, { 7, 5 }, { 7, 1 }, { 0, 0 },
	{ 3, 3 }, { 7, 3 }, { 0, 0 }},
        -3 /* */, 16
    }, {
	{{ -1, 1 }, { 2, 1 }, { 2, 3 }, { -1, 3 }, { -1, 5 }, 
	{ 2, 5 }, { 0, 0 },
	{ 5, 1 }, { 5, 3 }, { 0, 0 },
	{ 3, 5 }, { 5, 3 }, { 7, 5 }, { 0, 0 }},
        -3  /*  */, 16
    }, {
	{{ -1, 1 }, { 2, 1 }, { 2, 3 }, { -1, 3 }, { -1, 5 }, 
	{ 2, 5 }, { 0, 0 },
	{ 7, 1 }, { 3, 1 }, { 3, 5 }, { 7, 5 }, { 0, 0 },
	{ 3, 3 }, { 6, 3 }, { 0, 0 }},
        -3 /* */, 16
    }, {
	{{ -1, 1 }, { 2, 1 }, { 2, 3 }, { -1, 3 }, { -1, 5 }, 
	{ 2, 5 }, { 0, 0 },
	{ 3, 1 }, { 7, 1 }, { 0, 0 },
	{ 3, 5 }, { 7, 5 }, { 0, 0 },
	{ 4, 1 }, { 4, 5 }, { 0, 0 },
	{ 6, 1 }, { 6, 5 }, { 0, 0 }},
        -5 /* */, 16
    }, {
	{{ -1, 1 }, { 2, 1 }, { 2, 3 }, { -1, 3 }, { -1, 5 }, 
	{ 2, 5 }, { 0, 0 },
	{ 5, 1 }, { 5, 2 }, { 0, 0 },
	{ 3, 2 }, { 7, 2 }, { 0, 0 },
	{ 3, 4 }, { 3, 5 }, { 4, 5 }, { 6, 5 }, { 7, 5 }, { 7, 4 },
	{ 6, 3 }, { 4, 3 }, { 3, 4 }, { 0, 0 }},
        -4  /* */, 16
    }, {
	{{ -1, 1 }, { -1, 5 }, { 2, 5 }, { 2, 1 }, { 0, 0 },
	{ -1, 3 }, { 2, 3 }, { 0, 0 },
	{ 5, 1 }, { 5, 3 }, { 0, 0 },
	{ 3, 5 }, { 5, 3 }, { 7, 5 }, { 0, 0 }},
        -4  /*  */, 16
    }, {
	{{ 1, 1 }, { 8, 1 }, { 8, 5 }, { 1, 5 }, { 0, 0 },
         { 1, 1 }, { 8, 5 }, { 0, 0 },
         { 8, 1 }, { 1, 5 }, { 0, 0 }},
        -3  /* no font */, 16
    }
};

#if 1
#define it(y,sy) (int)((italic==0)?0:((italic==1)?((sy-y)/4.3):((sy-y)/3.3)))
#else
#define it(y,sy) 0
#endif

HanXDrawSimpleHangulScaleXY(dpy, win, gc, x, y, HanXSimpleHangulVectorFontp, dx, dy, sx, sy, bold, italic)
Display *dpy;
Window win;
GC gc;
int x, y;
struct vectorfont *HanXSimpleHangulVectorFontp;
int dx, dy;
float sx, sy;
int bold, italic;
{
    XPoint points[MAXPOINTS];
    int i, n;
    int linewidth;
    Point *p = HanXSimpleHangulVectorFontp->points;
    int npoints = HanXSimpleHangulVectorFontp->npoints;
    int boldidx;
    register float scalex = sx, scaley = sy;

    scalex *= HanXSimpleHangulVectorFontp->size / 16.0;
    scaley *= HanXSimpleHangulVectorFontp->size / 16.0;

    if (bold)
	boldidx = (0.5 + scalex) / 2 + 1;
    else
	boldidx = (0.5 + scalex) / 2;

    linewidth = (scalex < scaley) ? (int) scalex: (int) scaley;

    XSetLineAttributes(dpy, gc, linewidth, LineSolid, CapProjecting, JoinMiter);

    while (boldidx >= 0) {
	if (npoints >= 0) {
	    for (i = 0; i < npoints; i++) {
		points[i].x = (int)((dx + p[i].x) * scalex + 0.5);
		points[i].y = (int)((dy + p[i].y) * scaley + 0.5);
		points[i].x += x + boldidx +it(points[i].y,sy);
		points[i].y += y;
	    }
	    XDrawLines(dpy, win, gc, points, npoints, CoordModeOrigin);
	}
	else {
	    p = HanXSimpleHangulVectorFontp->points;
	    for (n = 0; n < -npoints; n++) {
		for (i = 0; p[i].y > 0; i++) {
		  points[i].x = (int)((dx + p[i].x) * scalex + 0.5);
		  points[i].y = (int)((dy + p[i].y) * scaley + 0.5);
		  points[i].x += x + boldidx +it(points[i].y,sy);
		  points[i].y += y;
		}
		XDrawLines(dpy, win, gc, points, i, CoordModeOrigin);
		p += i+1;
	    }
	}
#if DEBUG
	XSync(dpy, 0);
#endif
	boldidx--;
    }
}

HanXDrawSimpleHangulScale(dpy, win, gc, x, y, HanXSimpleHangulVectorFontp, dx, dy, scale)
Display *dpy;
Window win;
GC gc;
int x, y;
struct vectorfont *HanXSimpleHangulVectorFontp;
int dx, dy;
float scale;
{
    HanXDrawSimpleHangulScaleXY(dpy, win, gc, x, y, HanXSimpleHangulVectorFontp, dx, dy, scale, scale, 1);
}


static unsigned char MTABLE[32] = {
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 1, 0, 0, 	/*  */
    0, 0, 0, 1, 1, 0, 0, 0,	/* , */
    0, 0, 1, 1, 0, 0, 0, 0	/* , */
};

static unsigned char FTABLE[3][32] = {
    {
         0,  0,  1,  2,  3,  4,  5,  6,
         7,  8,  9, 10, 11, 12, 13, 14,
        15, 16, 17, 18, 19,  0,  0,  0,
         0,  0,  0,  0,  0,  0,  0,  0
    },{
         0,  0,  0, 20, 21, 22, 23, 24,
         0,  0, 25, 26, 27, 28, 29, 30,
         0,  0, 31, 32, 33, 34, 35, 36,
         0,  0, 37, 38, 39, 40,  0,  0
    },{
         0,  0,  1,  2, 41,  3, 42, 43,
         4,  6, 44, 45, 46, 47, 48, 49,
        50,  7,  0,  8, 51, 10, 11, 12,
        13, 15, 16, 17, 18, 19,  0,  0
    }
};

static unsigned char F_NOFONT = 52;


static HanXDrawSimpleHangulGljaScaleXY(dpy, win, gc, x, y, first, middle, last, scalex, scaley, bold, italic)
Display *dpy;
Window win;
GC gc;
int x, y;
unsigned int first, middle, last;
float scalex, scaley;
int bold, italic;
{
    struct vectorfont *p;

    p = &HanXSimpleHangulVectorFont[FTABLE[0][first]];
    if (MTABLE[middle])
	HanXDrawSimpleHangulScaleXY(dpy, win, gc, x, y, p, 2, 0, scalex, scaley, bold, italic);
    else
	HanXDrawSimpleHangulScaleXY(dpy, win, gc, x, y, p, 0, 0, scalex, scaley, bold, italic);

    p = &HanXSimpleHangulVectorFont[FTABLE[1][middle]];
    HanXDrawSimpleHangulScaleXY(dpy, win, gc, x, y, p, 0, 0, scalex, scaley, bold, italic);

    p = &HanXSimpleHangulVectorFont[FTABLE[2][last]];
    if (MTABLE[middle])
	HanXDrawSimpleHangulScaleXY(dpy, win, gc, x, y, p, 2, 8, scalex, scaley, bold, italic);
    else
	HanXDrawSimpleHangulScaleXY(dpy, win, gc, x, y, p, 5, 8, scalex, scaley, bold, italic);
}

HanXDrawStringHangulSub(dpy, win, gc, x, y, string, length, avgwidth, avgheight, bold, italic)
Display *dpy;
Window win;
GC gc;
int x, y;
unsigned char *string;
unsigned int length;
unsigned int avgwidth, avgheight;
int bold, italic;
{
    static unsigned char *buf = 0;
    static unsigned int bufsiz = 0;
    unsigned char first, second, third;
    int i;
    float scalex, scaley;
    int avgwidth2 = avgwidth * 2;
    int f, m, l;
    unsigned char buf3[10];

    scalex = avgwidth / 8.0;
    scaley = avgheight / 16.0;
    y -= avgheight;

#if DEBUG
    printf ("avgwidth = %d, avgheight = %d, length = %d\n", 
	avgwidth, avgheight, length );
    XSync(dpy, 0);
#endif

/*
    if (bufsiz < length) {
	if (buf) free(buf);
	bufsiz = ((length +1023)/ 1024) * 1024;
	buf = (unsigned char *)malloc(bufsiz);
    }
*/


    for (i = 0; i < length; i++) {
	if (string[i] & 0x80) {
            HanX_convert_ks_to_3(string[i], string[i+1], buf3);
            if (buf3[0] == 0xff) {
            }
            else {
/*
		    first = (buf[i] >> 2) & 0x1f;
		    second = (buf[i] << 3) & 0x18 | (buf[i+1] >> 5) & 0x7;
		    third = buf[i+1] & 0x1f;

		    HanXDrawSimpleHangulGljaScaleXY(dpy, win, gc, x, y, 
			first, second, third, scalex, scaley, bold, italic);
*/
	        HanXDrawSimpleHangulGljaScaleXY(dpy, win, gc, x, y, 
		    buf3[0], buf3[1], buf3[2], scalex, scaley, bold, italic);
            }

	    x += avgwidth2;
	    i++;
	}
	else {
	    x += avgwidth;
	}
    }

#if DEBUG
    XSync(dpy, 0);
    printf("HanXDrawStringHangul : done\n");
#endif
}
